#INCLUDE "dcMONTH.CH"
#include "XBPDEV.CH"
#INCLUDE "appevent.CH"

#DEFINE EVENT_SHOWRGB   xbeP_User+1
#DEFINE CRLF            CHR(13)+CHR(10)

FUNCTION Main()

LOCAL GetList[0], GetOptions, nRed := 0, nGreen := 0, nBlue := 0, oStatic
LOCAL oDPick

// call Dummy Function in DLL, else Resource are not avaiable ?
// DUMMY()
*DllLoad('DCMONTH.DLL')


@ 100,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT OBJECT oStatic ;
      SIZE 500,100 ;
      FONT '12.Lucida Console Bold' ;
      OPTIONS XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER ;   // add by Jimmy
      RESIZE DCGUI_RESIZE_RESIZEONLY


@ 200,0 DCMONTH SIZE 500,50              ;
        RESIZE DCGUI_RESIZE_RESIZEONLY                           // add by Jimmy


/*****************************************************************

OBJECT oDPick   ;

        MULTISELECT     .T.      ;
        SHOWTODAY       .T.      ;
        BOLDDAYS        .T.      ;

OnItemDblClick                            // User Codeblock
MultiSelect                               // multi Day select
WeekNumbers                               // show Weeknumber
NoToday                                   // dont show Today
NoTodayCircle                             // dont show Circle around Today
BoldDays                                  // show Bold Days
TitlebarFGcolor                           // Titlebar - Weekdays - Weeknumber Color
TitlebarBGcolor                           // Titlebar Background Color
BodyFGcolor                               // Month Body Foreground Color
BodyBGcolor                               // Month Body Background Color
TrailingColor
useVisualStyle                            // use visual Style
dDaysStart                                // 1st. Day Start
dDaysEnd                                  // 2nd. Day End
aBoldDays                                 // hold Bold Days


DCUSEREVENT EVENT_SHOWRGB ACTION {|| ShowRGB(oDPick,SetAppWindow())}

*****************************************************************/

DCGETOPTIONS PIXEL RESIZE

DCREAD GUI FIT TITLE 'Month Day Pick Demo' OPTIONS GetOptions ;
   CLEAREVENTS

*  EVAL {||PostAppEvent(EVENT_SHOWRGB,,,oStatic)} ;

RETURN nil

* -----------

PROC appsys ; RETURN

* -----------

FUNCTION DC_DxeMonth( aParams )

LOCAL aGetList := aParams[1], nGetListPointer := aParams[2], ;
      oParent := aParams[3], aPos := aParams[4], aSize := aParams[5], ;
      aPres := aParams[6], lVisible := aParams[7], oGetList := aParams[8]

LOCAL aGetListItem := aGetList[nGetListPointer]       , ;
      aOptions     := aGetListItem[xGETLIST_OPTIONS]  , ;
      aColor       := aGetListItem[aGETLIST_COLOR]    , ;
      aOptions2    := aGetListItem[xGETLIST_OPTIONS2] , bBlock

LOCAL aOptions3    := aGetListItem[xGETLIST_OPTIONS3]   // Resource DLL

LOCAL oMonth

*  oMonth := DC_Month():New( oParent,,aPos,aSize,,,oGetList )
   oMonth := DXE_MonthPick():New( oParent,,aPos,aSize)

   SetOption( @oMonth:MultiSelect, aOptions[1] )
   SetOption( @oMonth:NoToday    , aOptions[2] )
   SetOption( @oMonth:BoldDays   , aOptions[9] )


   IF Valtype(aOptions3) == "A"                    // Resource DLL
      SetOption( @oMonth:cDllName, aOptions3[2] )
      SetOption( @oMonth:cImgType, aOptions3[1] )
   ENDIF

   oMonth:Drawmode := XBP_DRAW_OWNERADVANCED

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')

   IF Valtype(bBlock) = 'B'
      Eval( bBlock, oMonth )
   ENDIF

   bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
   IF Valtype(bBlock) = 'B'
      Eval( bBlock, oMonth )
   ENDIF

   oMonth:Create()


   IF Valtype(aOptions[3]) == 'N'
      oMonth:WeekNumbers := aOptions[3]
   ENDIF
   IF Valtype(aOptions[6]) == 'N'
      oMonth:SetMaxSelection( aOptions[6] )
   ENDIF
   IF Valtype(aOptions[7]) == 'C'
      oMonth:SetDateTime(aOptions[7])
   ENDIF
   IF Valtype(aOptions[8]) == 'N'
      oMonth:SetFirstDayofWeek(aOptions[8])
   ENDIF

   IF Valtype(aOptions2) == 'A'
      oMonth:SetSelectedRange( aOptions2 )
   ENDIF

RETURN oMonth

* ----------

STATIC FUNCTION SetOption( xIvar, xOption )

IF xOption # NIL
  xIvar := xOption
ENDIF

RETURN nil

* ----------

STATIC FUNCTION ShowRGB(oDPick,oDlg)

   oDPick:OnItemDblClick := {|dDate1,dDate2,oSelf| Msgbox( DTOC(dDate1)+CRLF+DTOC(dDate2),LTRIM(STR((dDate2-dDate1)+1))+" Days" ),;
                              oDPick:destroy(),;
                              PostAppEvent(xbeP_Close,,,oDlg) }

RETURN nil

* ----------

CLASS DC_DxeMonthPick FROM DXE_MonthPick, DC_XbaseParts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

::DC_XbaseParts:init(oGetList,,self)

::DXE_MonthPick:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DXE_MonthPick:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:setOrig(self)

RETURN self

ENDCLASS


